import { Application, Handler, Router } from 'express';
import { OpenAPISpecification } from './openapi';
import { ExpressOpenAPIPlugin } from './plugins';
export * from './joi';
export * from './plugins';
export { OpenAPISpecification } from './openapi';
export declare class ExpressOpenAPI {
    private plugins;
    private useStringStashKey;
    private specification;
    constructor({ specification, useStringStashKey, }?: {
        specification?: OpenAPISpecification;
        /**
         * if you're using a library that dynamically modifies your middlewares
         * and the `populateSpecification` method is not working properly,
         * then set this to `true`
         */
        useStringStashKey?: boolean;
    });
    registerPlugin: <StashType, GetMiddleware extends (...params: any[]) => Handler>(plugin: ExpressOpenAPIPlugin<StashType, GetMiddleware>) => (...params: Parameters<GetMiddleware>) => ReturnType<GetMiddleware>;
    populateSpecification: (app: Application | Router, basePath?: string | undefined) => OpenAPISpecification;
}
