import { Schema } from 'joi';
import { JoiSchema, JoiSchemaRule, JoiSchemaTerms } from './types';
export declare const isSchemaType: <Type extends string>(schema: Schema, type: Type) => schema is Type extends "string" | "number" | "boolean" | "symbol" | "object" | "function" | "any" | "alternatives" | "array" | "binary" | "date" | "link" ? JoiSchema<Type> : import("joi").AnySchema;
export declare const isRuleName: <Type extends "string" | "number" | "boolean" | "symbol" | "object" | "function" | "any" | "alternatives" | "array" | "binary" | "date" | "link", Name extends Exclude<keyof JoiSchema<Type>, "$_super" | "$_terms" | "$_addRule" | "$_compile" | "$_createError" | "$_getFlag" | "$_getRule" | "$_mapLabels" | "$_match" | "$_modify" | "$_mutateRebuild" | "$_mutateRegister" | "$_property" | "$_reach" | "$_rootReferences" | "$_setFlag" | "$_validate" | "_rules" | "_singleRules" | "_invalids" | "_valids" | "_preferences">>(rule: JoiSchemaRule<Type, Exclude<keyof JoiSchema<Type>, "$_super" | "$_terms" | "$_addRule" | "$_compile" | "$_createError" | "$_getFlag" | "$_getRule" | "$_mapLabels" | "$_match" | "$_modify" | "$_mutateRebuild" | "$_mutateRegister" | "$_property" | "$_reach" | "$_rootReferences" | "$_setFlag" | "$_validate" | "_rules" | "_singleRules" | "_invalids" | "_valids" | "_preferences">>, name: Name) => rule is JoiSchemaRule<Type, Name>;
export declare const isDeprecated: (schema: Schema) => boolean;
export declare const extractAlternativeSchemas: (conditionals: NonNullable<JoiSchemaTerms<'any'>['whens'] | JoiSchemaTerms<'alternatives'>['matches']>) => Schema[];
export declare const getMetas: <Metas extends {
    [key: string]: any;
} = {
    [key: string]: any;
}>(schema: JoiSchema<'any'>) => Metas;
