import { AsyncValidationOptions, Schema, SchemaLike, ValidationError } from 'joi';
import { Handler } from 'express';
import { ExpressOpenAPIPlugin } from './types';
export declare type RequestSegment = 'body' | 'cookies' | 'headers' | 'params' | 'query' | 'signedCookies';
declare type JoiRequestSchemaMap = Map<RequestSegment, Schema | undefined>;
declare type JoiRequestValidationSchema = {
    [segment in RequestSegment]?: SchemaLike;
};
export declare type GetJoiRequestValidatorMiddleware = (joiRequestSchema: JoiRequestValidationSchema, joiValidationOptions?: AsyncValidationOptions) => Handler;
declare type JoiRequestValidatorPlugin = ExpressOpenAPIPlugin<JoiRequestSchemaMap, GetJoiRequestValidatorMiddleware>;
export declare class RequestValidationError extends Error {
    segment: RequestSegment;
    validationError: ValidationError;
    constructor(validationError: ValidationError, segment: RequestSegment);
}
export declare const getJoiRequestValidatorPlugin: ({ segmentOrder, }?: {
    segmentOrder?: import("../types").RequestSegment[] | undefined;
}) => JoiRequestValidatorPlugin;
export {};
